-- Bindings
BINDING_HEADER_RIBHEADER = "RaidIconBar";
BINDING_NAME_RIBSNAP = "MouseSnap";

def_posx = 0;
def_posy = 0;

alwaysVisible = 0;

RIB_AGGROCOLORS = { };
RIB_AGGROCOLORS["5"] = "ffff1919";
RIB_AGGROCOLORS["4"] = "ffff803f";
RIB_AGGROCOLORS["3"] = "ffffff00";
RIB_AGGROCOLORS["2"] = "ff3fc03f";
RIB_AGGROCOLORS["1"] = "ff808080";

-- functions
function RaidIconBar_OnLoad()

	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("PARTY_MEMBERS_CHANGED");
	this:RegisterEvent("UNIT_THREAT_SITUATION_UPDATE");	
	this:RegisterEvent("UNIT_THREAT_LIST_UPDATE");
	this:RegisterEvent("PLAYER_TARGET_CHANGED");

	SLASH_RAIDICONBAR1 = "/raidiconbar";
  	SLASH_RAIDICONBAR2 = "/rib";
  	SlashCmdList["RAIDICONBAR"] = function(msg)
		RaidIconBar_SlashCommandHandler(msg);
	end
end

function RaidIconBar_SlashCommandHandler(msg)
	if (msg == "reload") then
	 	ReloadUI();
	end
	
	if (msg == "show") then
	 	alwaysVisible = 1;
	 	RaidIconBar_OnEvent();
	elseif (msg == "hide") then
	 	alwaysVisible = 0;
	 	RaidIconBar_OnEvent();
	else
	end
end

function RaidIconBar_OnClick(self, button, down)
	if (button == "LeftButton") then
   		id = this:GetID();
   		SetRaidTarget("target",id);
	elseif (button == "RightButton") then
		SetRaidTarget("target",0);
	end
end

function RaidIconBar_OnEvent(event)
	if (event == "PLAYER_ENTERING_WORLD" or event == "PARTY_MEMBERS_CHANGED") then
		local frame = getglobal("RaidIconBarFrame");
	
		if (alwaysVisible == 0) then
   			if (frame) then
				if( GetNumPartyMembers() == 0 ) then
    	  			frame:Hide();
   				else
   					if ( UnitIsPartyLeader("player") ) then
    	  				frame:Show();
     	 			else
     	 				frame:Hide();
     	 			end
   				end
   			end
   		else
   			frame:Show();
  	 	end
   	end
   	
   	if (event == "UNIT_THREAT_SITUATION_UPDATE" or event == "UNIT_THREAT_LIST_UPDATE" or event == "PLAYER_TARGET_CHANGED") then
   		RaidIconBar_ThreatSituationUpdate();
   	end
end

function RaidIconBar_ThreatSituationUpdate()
	local infotext = "";

	targetExists = UnitExists("target");
	
	if (targetExists == 1) then
		targetIsEnemy = UnitIsEnemy("player", "target");
	
		if (targetIsEnemy == 1) then
			local isTanking, status, percentage = UnitDetailedThreatSituation("player", "target");
			
			if (not percentage) then
				percentage = 0;
			end
			
 			hexcolor = RaidIconBar_AggroColor(percentage);
 			infotext = "|c"..hexcolor..format("%d", percentage).." % Aggro|r";
 		end
 	end
 	
 	RIBPlayerPortraitAggro:SetText(infotext);
end


-- Used for quests and enemy coloration
function RaidIconBar_AggroColor(percentage)

	if (not percentage) then
		color = RIB_AGGROCOLORS["1"];
	elseif ( percentage >= 80 ) then
		color = RIB_AGGROCOLORS["5"];
	elseif ( percentage >= 70 ) then
		color = RIB_AGGROCOLORS["4"];
	elseif ( percentage >= 60 ) then
		color = RIB_AGGROCOLORS["3"];
	elseif ( percentage >= 50 ) then
		color = RIB_AGGROCOLORS["2"];
	else
		color = RIB_AGGROCOLORS["1"];
	end
	return color;
end

function RaidIconBar_SnapDown()
	local frame = getglobal("RaidIconBarFrame");
	
	def_posx = frame:GetLeft();
	def_posy = frame:GetBottom();
	
	x, y = GetCursorPosition();
	
	_, _, w, h = UIParent:GetRect();
	
	dh = 768;
	dw = w/h*dh;
	
	x = x / dw * w;	
	y = y / dh * h;
	
	local frame = getglobal("RaidIconBarFrame");
	frame:ClearAllPoints();
	frame:SetPoint("CENTER", UIParent, "BOTTOMLEFT", x, y);
end

function RaidIconBar_SnapUp()
	local frame = getglobal("RaidIconBarFrame");
	frame:ClearAllPoints();
	frame:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", def_posx, def_posy);
end